// Copyright (c) 2014-2015 TouchType Ltd. All Rights Reserved.

var muteSoundEffects = false;

function setLayoutHeight(newHeight) {
    $('.keyboard').css('height', newHeight);
}

function requestLayout(layout) {
    $('.layout').addClass('old');
    $('.layout.'+layout).removeClass('old');
}

function changeLayoutSet(layoutSet, selected) {
    $('.keyboard').html(layoutSet);
    if(selected != null) {
        requestLayout(selected);
    }
}

function setDynamicKey(selector, oldClass, newClass, newText) {
    if (oldClass != newClass || newText != null) {
        var elem = $ ('.key-'+selector);
        if (newClass != null && newClass != oldClass) {
            elem.addClass(newClass);
        }    
        if (oldClass != null && oldClass != newClass) {
            elem.removeClass(oldClass);
        }
        if (newText != null && $.type(newText) === "string") {
            elem.attr('data-label', newText);
            $('.key-'+selector+'>.label').text(newText);
        }
        if (newText != null && $.type(newText) === "array") {            
            $('.key-'+selector+'>.label').each(function (index, element) {
                $(this).text(newText[index]).attr('data-label', newText[index]);
            });
        }
    }
}

function applyThemeSpecification(themeStyle, themeScript) {
    $('#themestyle').attr('href', themeStyle);
    $('#themestyle').text("");

    // Remove any pre-existing theme script from HTML
    $('#themescript').remove();

    // Reset the state for any javascript from the previous theme
    if (typeof destroyTheme === 'function') {
        destroyTheme();
    }

    // If javascript has been specified for this theme then add it to the page
    if (themeScript !== null) {
        var elem = document.createElement('script');
        elem.id = 'themescript';
        elem.type = 'text/javascript';
        elem.src = themeScript;

        $('head').append(elem);
        initTheme();
    }
}

function keyDown(keytype) {
    var elems = document.getElementsByClassName(keytype);
    for (var i=elems.length; i--; ) {
        elems[i].classList.add('pressed');

        if (isKeyOnLayout(elems[i], 'primary')) {
            var event = new Event('key-down');
            event.data = elems[i].classList;
            document.dispatchEvent(event);
        }
    }
}

function keyUp(keytype) {
    var elems = document.getElementsByClassName(keytype);
    for (var i=elems.length; i--; ) {
        elems[i].classList.remove('pressed');
    }
}

function keySlideIn(keytype) {
}

function keySlideOut(keytype) {
    var elems = document.getElementsByClassName(keytype);
    for (var i=elems.length; i--; ) {
        elems[i].classList.remove('pressed');
    }
}

function keyCancel(keytype) {
    var elems = document.getElementsByClassName(keytype);
    for (var i=elems.length; i--; ) {
        elems[i].classList.remove('pressed');
    }
}

function isKeyOnLayout(keyElem, layoutName) {
    var parentNodeClassList = keyElem.parentNode.classList;
    return parentNodeClassList.contains(layoutName) && parentNodeClassList.contains('layout');
}

function playSound(assetPath) {
    if (!muteSoundEffects) {
        ClarityAudio.play(assetPath);
    }
}
